# file test_countCar.py
import optimism as opt

# BUGGY version of countChar
def countChar(char, word):
    '''Return the number of time char occurs in word, ignoring case.'''
    counter = 0
    for i in range(1, len(word)-1):
        if word[i] == char.lower():
            counter += 1
    return counter

def test_countChar():
    ''' A simple illustration of using 
        optimism to perform input/ouptut   
        testing on the countChar function
    ''' 
    tester = opt.testFunction(countChar) 
    tester.case('s', 'Mississippi')\
               .checkReturnValue(4) 
    tester.case('p', 'Mississippi')\
               .checkReturnValue(2) 
    tester.case('a', 'Mississippi')\
               .checkReturnValue(0) 
    tester.case('i', 'Mississippi')\
               .checkReturnValue(4)
    tester.case('I', 'MISSISSIPPI')\
               .checkReturnValue(4) 
    tester.case('m', 'mississippi')\
               .checkReturnValue(1)
               
# test_countChar()

testCases = [
  ('s', 'Mississippi', 4),
  ('p', 'Mississippi', 2),
  ('a', 'Mississippi', 0),
  ('i', 'Mississippi', 4),
  ('I', 'MISSISSIPPI', 4),
  ('m', 'mississippi', 1),
]

def test_countChar2():
    ''' test countChar cases in testCases
    ''' 
    tester = opt.testFunction(countChar)
    for char, word, expected in testCases:
        tester.case(char, word)\
                   .checkReturnValue(expected) 

test_countChar2()



